/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1996, by WATCOM International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of WATCOM International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*/

/*************************************************************************
 *
 * WOleViewableObject -- Ole Viewable Object interface family
 *
 *   Events:
 *
 *      ViewableObjectDraw      -- displays viewable object
 *
 *************************************************************************/

#ifndef _WOLEVWOB_HPP_INCLUDED
#define _WOLEVWOB_HPP_INCLUDED

#ifndef _WNO_PRAGMA_PUSH
#pragma pack(push,8);
#pragma enum int;
#endif

#ifndef _WOLETYPE_HPP_INCLUDED
#  include "woletype.hpp"
#endif
#ifndef _WOLEIFAM_HPP_INCLUDED
#  include "woleifam.hpp"
#endif

typedef int ( __stdcall *WVOContinueFn )( WDWord dwContinue );

struct WViewableObjectDrawEventData : public WEventData {
    WDWord              dwDrawAspect;
    WLong               lindex;
    void                *pvAspect;
    WDVTargeTDevice     *ptd;
    WDeviceHandle       hdcTargetDev;
    WDeviceHandle       hdcDraw;
    WRect               rectBounds;
    WRect               rectWBounds;
    WVOContinueFn       pfnContinue;
    WDWord              dwContinue;
};

// forward class declarations
class WOleViewableObject_IVO2;

class WCMCLASS WOleViewableObject : public WOleInterfaceFamily
{
    WDeclareSubclass( WOleViewableObject, WOleInterfaceFamily );

    friend class WOleViewableObject_IVO2;
    
    public:

    /**********************************************************
     * Constructors and Destructors
     *********************************************************/
        WOleViewableObject( WOleServerObject *serverObject );
        virtual ~WOleViewableObject();

    /**************************************************************
     * Properties
     **************************************************************/

    /**************************************************************
     * Methods
     **************************************************************/

        // overrides
        virtual WBool QueryInterface( const WCLSID & clsid, void **iface );

    /**********************************************************
     * Operators
     *********************************************************/

    /**********************************************************
     * Data Members
     *********************************************************/

    protected:

        WOleViewableObject_IVO2 *_pIViewObject2;

};

    
#ifndef _WNO_PRAGMA_PUSH
#pragma enum pop;
#pragma pack(pop);
#endif

#endif // _WOLEVWOB_HPP_INCLUDED

